#pragma hdrstop

#include "OADOAdapter.h"
#include "ADODataDriverEh.hpp"

#pragma package(smart_init)

using namespace OADOAdapter;

CAdapter::CAdapter():
          Form(new TfmWait(NULL))
{
}

void CAdapter::ShowWait(const AnsiString Comment)
{
    if (Comment.Trim() != "")
    {
        Form->laComment->Caption = Comment;
        Form->laComment->Visible = true;
    } else
    {
        Form->laComment->Visible = false;
    }
    Form->Show();
    Form->Update();
}

void CAdapter::HideWait()
{
    if (Form->Visible) Form->Hide();
}

TADOConnection* CAdapter::Connection()
{
    PResTable r = Execute("Main.Connection", PTable(NULL));
    if (r->Valid)
    {
        return reinterpret_cast<TADOConnection*>(static_cast<unsigned int>((*r)[0]["Connection"]));
    }
    return NULL;
}

PResTable CAdapter::Fields(TFields *Src)
{
    PResTable Dest(new CResTable(true));
    TField *Field = NULL;
    CFields Fields;
    for (int i = 0; i < Src->Count; i++)
    {
        Field = (*Src)[i];
        Fields.Insert(Field->FieldName, Field->Value);
    }
    Dest->Insert(Fields);
    return Dest;
}


PResTable CAdapter::Table(TDataSet *Src)
{
    PResTable Res(new CResTable(true));

    TFields *Fields = Src->Fields;
    TField *Field = NULL;
    for (Src->First(); !Src->Eof; Src->Next())
    {
        CFields Record;
        for (int i = 0; i < Fields->Count; i++)
        {
            Field = (*Fields)[i];
            Record.Insert(Field->FieldName, Field->Value);
        }
        Res->Insert(Record);
    }

    return Res;
}

void CAdapter::SetConnection(TComponent *Src)
{
    TADOConnection *c = Connection();

    TCustomADODataSet *ads = NULL;
    TADODataDriverEh  *add = NULL;
    TADOCommand       *adc = NULL;

    for (int i = 0; i < Src->ComponentCount; ++i)
    {
        TComponent *Test = Src->Components[i];
        ads = dynamic_cast<TCustomADODataSet*>(Test);
        if (ads)
        {
            ads->Connection = c;
            continue;
        }
        add = dynamic_cast<TADODataDriverEh*>(Test);
        if (add)
        {
            add->ADOConnection = c;
            continue;
        }
        adc = dynamic_cast<TADOCommand*>(Test);
        if (adc)
        {
            adc->Connection = c;
            continue;
        }
    }
}
