#ifndef OAdapterH
#define OAdapterH

#include "OAdapterUtils.h"

#include <Forms.hpp>

namespace OAdapter
{
    using namespace OAdapterUtils;
    ////////////////////////////////////////////////////////////////////////////
    //
    //   
    //
    template <class CFunc> class PACKAGE CAdapterTmp: public map<AnsiString, CFunc>
    {
    public:
        //typedef CAdapterTmp<CFunc> AdapterClass;
        bool RegisterFunction(const AnsiString Name, const CFunc Func)
        {
            if (find(Name) != end()) return false;
            map<AnsiString, CFunc>::operator[](Name) = Func;
            return true;
        }

        bool UnregisterFunction(const AnsiString Name)
        {
            if (end() == find(Name)) return false;
            erase(Name);
            return true;
        }
    };

    ////////////////////////////////////////////////////////////////////////////
    //
    // -        
    //   
    //
    typedef PResTable __fastcall (__closure *PAdapterFunc)(PTable);

    ////////////////////////////////////////////////////////////////////////////
    //
    //  ,      
    //
    class PACKAGE CAdapter: private CAdapterTmp<PAdapterFunc>
    {
    public:
        //typedef CAdapter AdapterClass;
        AnsiString InstanceName;
        CAdapterTmp<PAdapterFunc>::RegisterFunction;
        CAdapterTmp<PAdapterFunc>::UnregisterFunction;
        PResTable Execute(const AnsiString Name, PTable Values) const;
    };

    ////////////////////////////////////////////////////////////////////////////
    //
    //  ,   .
    // Main Form Associated Adapter
    //
    class PACKAGE CMFAAdapter: public CAdapter
    {
    public:
        TForm* MainForm();
    };
}

#endif
