#pragma hdrstop

#include "OUtils.h"

#include <Forms.hpp>

#pragma package(smart_init)

void __fastcall OUtils::ErrorMessage(const AnsiString Msg)
{
    MessageBox(Application->Handle,
               Msg.c_str(),
               Application->Title.c_str(),
               MB_APPLMODAL + MB_ICONERROR);
}

void __fastcall OUtils::CatchEllipsisMessage(const AnsiString Msg)
{
    OUtils::ErrorMessage(Msg);
}

void __fastcall OUtils::CatchExceptionMessage(const AnsiString Msg, const Exception &E)
{
    MessageBox(Application->Handle,
               AnsiString(Msg +
                          "\nc :\n\"" +
                          E.Message.Trim() +
                          "\"").c_str(),
               Application->Title.c_str(),
               MB_APPLMODAL + MB_ICONERROR);
}

////////////////////////////////////////////////////////////////////////////
int __fastcall OUtils::QuestionYesNo(const AnsiString Msg)
{
    return MessageBox(Application->Handle,
                      Msg.c_str(),
                      Application->Title.c_str(),
                      MB_APPLMODAL + MB_ICONQUESTION + MB_YESNO);
}

////////////////////////////////////////////////////////////////////////////
Variant __fastcall OUtils::isnull(Variant Exp, Variant NullRes)
{
    if (Exp.IsNull()) return NullRes;
    return Exp;
}

////////////////////////////////////////////////////////////////////////////
void __fastcall OUtils::AdjustDropDownForm(TControl *pHostControl, TControl *pWhat)
{
    RECT WorkArea;
    SystemParametersInfo(SPI_GETWORKAREA, 0, &WorkArea, 0);
    TPoint ptHost = pHostControl->ClientToScreen(Point(0, 0));

    pWhat->Left = ptHost.x;
    pWhat->Top  = ptHost.y + pHostControl->Height + 1;

    if (pWhat->Width > WorkArea.right - WorkArea.left)
    {
        pWhat->Width = WorkArea.right - WorkArea.left;
    }

    if (pWhat->Left + pWhat->Width > WorkArea.right) pWhat->Left = WorkArea.right - pWhat->Width;
    if (pWhat->Left < WorkArea.left)          pWhat->Left = WorkArea.left;

    if (pWhat->Top + pWhat->Height > WorkArea.bottom)
    {
        if (ptHost.y - WorkArea.top > WorkArea.bottom - ptHost.y - pHostControl->Height)
        {
            pWhat->Top = ptHost.y - pWhat->Height;
        }
    }

    if (pWhat->Top < WorkArea.top)
    {
        pWhat->Height = pWhat->Height - (WorkArea.top - pWhat->Top);
        pWhat->Top = WorkArea.top;
    }

    if (pWhat->Top + pWhat->Height > WorkArea.bottom) pWhat->Height = WorkArea.bottom - pWhat->Top;
}

